//+------------------------------------------------------------------+
//|                                                     SmWPRExp.mq4 |
//|       30.08.2006  Translated on MT4 by Oleg Golozubov aka Maloma |
//+------------------------------------------------------------------+
#property copyright " Copyright  2006, HomeSoft Corp."
#property link      " spiky@sinet.spb.ru"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Gold
#property indicator_color2 Red
#property indicator_width1 2

extern int    t3p       = 8;
extern double b         = 0.7;
extern int    pers      = 96;
extern int    perf      = 14; 
extern int    psel      =-30;
extern int    pbuy      =-70;
extern int    mBar      = 300;

double Buffer1[],Buffer2[],e1,e2,e3,e4,e5,e6,c1,c2,c3,c4,n,w1,w2,b2,b3,dpo,t3,wpr,wprone,wprtwo,trig;
int    i;
//+------------------------------------------------------------------+
int init() {
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID);
   SetIndexBuffer(0, Buffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID);
   SetIndexBuffer(1, Buffer2);
   SetIndexEmptyValue(1,0.0);
   b2=b*b; 
   b3=b2*b; 
   c1=-b3; 
   c2=(3*(b2+b3)); 
   c3=-3*(2*b2+b+b3); 
   c4=(1+3*b+b3+3*b2); 
   n=t3p;
if(n<1) n=1; 
   n=1+0.5*(n-1); 
   w1=2/(n+1); 
   w2=1-w1;
   Comment("");
   return(0); }
//+------------------------------------------------------------------+
int start() {


for(i=mBar;i>=0;i--) 
 { 
    wprone=iCustom(NULL,0,"#SmWPRExp",t3p,b,pers,psel,pbuy,mBar,0,i);
    wprtwo=iCustom(NULL,0,"#SmWPRExp",t3p,b,perf,psel,pbuy,mBar,0,i);
    wpr=NormalizeDouble(((wprone+wprtwo)/2),2);

    e1=w1*wpr+w2*e1; e2=w1*e1+w2*e2; e3=w1*e2+w2*e3; e4=w1*e3+w2*e4; e5=w1*e4+w2*e5; e6=w1*e5+w2*e6;
    t3=c1*e6+c2*e5+c3*e4+c4*e3;
   
if (t3>=-50) trig=psel; 
if (t3<-50) trig=pbuy;
    Buffer2[i]=trig; 
    Buffer1[i]=t3; 
 }   
return(0); 
 }
//+------------------------------------------------------------------+