//+------------------------------------------------------------------+
//|                                                   #OSmWPRExp.mq4 |
//|                          Copyright  2008, HomeSoft-Tartan Corp. |
//|                                          http://www.fxexperts.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, HomeSoft-Tartan Corp."
#property link      "http://www.fxexperts.ru"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Lime
#property indicator_color2 Red
#property indicator_color3 White
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  2

extern int    t3p       = 8;
extern double b         = 0.7;
extern int    pers      = 96;
extern int    perf      = 14;
extern int    psel      =-20;
extern int    pbuy      =-80;
extern double trig      = 2;
extern int    mBar      = 150;
//===================================================================
double UpBuff[],DnBuff[],TBuff[],wprone,wprnul,swpr;
int    cnt;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(0, UpBuff);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(1, DnBuff);
   SetIndexEmptyValue(1,0.0);   
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, TBuff);   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {  
//----
   for (cnt=mBar;cnt>=0;cnt--) {UpBuff[cnt]=0;DnBuff[cnt]=0;}

   for(cnt=mBar;cnt>=0;cnt--) 
 { 
    wprone=iCustom(NULL,0,"#2SSmWPRExp",t3p,b,pers,perf,psel,pbuy,mBar,0,cnt+1);
    wprnul=iCustom(NULL,0,"#2SSmWPRExp",t3p,b,pers,perf,psel,pbuy,mBar,0,cnt);
    
    swpr=NormalizeDouble((2*(wprnul-wprone)),2);
   
   if (swpr>=0) {UpBuff[cnt]=swpr;TBuff[cnt]=trig;}
   if (swpr<0) {DnBuff[cnt]=swpr;TBuff[cnt]=-trig;}
 }   
//----
   return(0);
  }
//+------------------------------------------------------------------+